Index: palm/trunk/SOURCE/lpm_collision_kernels.f90
===================================================================
--- palm/trunk/SOURCE/lpm_collision_kernels.f90	(revision 1821)
+++ palm/trunk/SOURCE/lpm_collision_kernels.f90	(revision 1822)
@@ -19,5 +19,9 @@
 ! Current revisions:
 ! -----------------
-!
+! PALM kernel has been deleted.
+! Bugfix in the calculation of the turbulent enhancement factor of the
+! collection efficiency.
+!
+! Unused variables removed.
 ! 
 ! Former revisions:
@@ -96,12 +100,9 @@
 !> This module calculates collision efficiencies either due to pure gravitational
 !> effects (Hall kernel, see Hall, 1980: J. Atmos. Sci., 2486-2507) or
-!> including the effects of (SGS) turbulence (Wang kernel, see Wang and
-!> Grabowski, 2009: Atmos. Sci. Lett., 10, 1-8). The original code has been
+!> including the effects of turbulence (Wang kernel, see Wang and
+!> Grabowski, 2009: Atmos. Sci. Lett., 10, 1-8, and Ayala et al., 2008: 
+!> New J. Phys., 10, 075016). The original code has been
 !> provided by L.-P. Wang but is substantially reformatted and speed optimized
 !> here.
-!>
-!> @attention Physical quantities (like g, densities, etc.) used in this module
-!>            still have to be adjusted to those values used in the main PALM code.
-!>            Also, quantities in CGS-units should be converted to SI-units eventually.
 !------------------------------------------------------------------------------!
  MODULE lpm_collision_kernels_mod
@@ -114,5 +115,6 @@
 
     USE particle_attributes,                                                   &
-        ONLY:  collision_kernel, dissipation_classes, particles, radius_classes
+        ONLY:  collision_kernel, dissipation_classes, particles,               &
+               radius_classes
 
     USE pegrid
@@ -123,25 +125,23 @@
     PRIVATE
 
-    PUBLIC  ckernel, collision_efficiency_rogers, init_kernels, &
-            rclass_lbound, rclass_ubound, recalculate_kernel
+    PUBLIC  ckernel, init_kernels, rclass_lbound, rclass_ubound,               &
+            recalculate_kernel
 
     REAL(wp) ::  epsilon       !<
-    REAL(wp) ::  eps2          !<
     REAL(wp) ::  rclass_lbound !<
     REAL(wp) ::  rclass_ubound !<
     REAL(wp) ::  urms          !<
-    REAL(wp) ::  urms2         !<
-
-    REAL(wp), DIMENSION(:),   ALLOCATABLE ::  epsclass !<
-    REAL(wp), DIMENSION(:),   ALLOCATABLE ::  radclass !<
-    REAL(wp), DIMENSION(:),   ALLOCATABLE ::  winf     !<
+
+    REAL(wp), DIMENSION(:),   ALLOCATABLE ::  epsclass  !< dissipation rate class
+    REAL(wp), DIMENSION(:),   ALLOCATABLE ::  radclass  !< radius class
+    REAL(wp), DIMENSION(:),   ALLOCATABLE ::  winf      !<
     
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ec       !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ecf      !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  gck      !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  hkernel  !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  hwratio  !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ec        !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ecf       !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  gck       !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  hkernel   !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  hwratio   !<
     
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  ckernel !<
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ckernel !<
 
     SAVE
@@ -149,8 +149,4 @@
 !
 !-- Public interfaces
-    INTERFACE collision_efficiency_rogers
-       MODULE PROCEDURE collision_efficiency_rogers
-    END INTERFACE collision_efficiency_rogers
-
     INTERFACE init_kernels
        MODULE PROCEDURE init_kernels
@@ -186,6 +182,6 @@
        IF ( collision_kernel(6:9) == 'fast' )  THEN
 
-          ALLOCATE( ckernel(1:radius_classes,1:radius_classes,               &
-                    0:dissipation_classes), epsclass(1:dissipation_classes), &
+          ALLOCATE( ckernel(1:radius_classes,1:radius_classes,                 &
+                    0:dissipation_classes), epsclass(1:dissipation_classes),   &
                     radclass(1:radius_classes) )
 
@@ -195,5 +191,5 @@
           rclass_lbound = LOG( 1.0E-6_wp )
           rclass_ubound = LOG( 2.0E-4_wp )
-          radclass(1)   = 1.0E-6_wp
+          radclass(1)   = EXP( rclass_lbound )
           DO  i = 2, radius_classes
              radclass(i) = EXP( rclass_lbound +                                &
@@ -377,9 +373,12 @@
 ! Description:
 ! ------------
-!> Calculation of gck
-!> This is from Aayala 2008b, page 37ff.
-!> Necessary input parameters: water density, radii of droplets, air density,
-!> air viscosity, turbulent dissipation rate, taylor microscale reynolds number,
-!> gravitational acceleration  --> to be replaced by PALM parameters
+!> Calculation of effects of turbulence on the geometric collision kernel 
+!> (by including the droplets' average radial relative velocities and their 
+!> radial distribution function) following the analytic model by Aayala et al. 
+!> (2008, New J. Phys.). For details check the second part 2 of the publication,
+!> page 37ff.
+!>
+!> Input parameters, which need to be replaced by PALM parameters:
+!>    water density, air density
 !------------------------------------------------------------------------------!
     SUBROUTINE turbsd
@@ -392,6 +391,4 @@
 
        IMPLICIT NONE
-       
-       LOGICAL, SAVE ::  first = .TRUE. !<
 
        INTEGER(iwp) ::  i     !<
@@ -442,67 +439,61 @@
        REAL(wp) ::  z         !<
 
-       REAL(wp), DIMENSION(1:radius_classes) ::  st  !<
-       REAL(wp), DIMENSION(1:radius_classes) ::  tau !<
-       
-!
-!--    Initial assignment of constants
-       IF ( first )  THEN
-
-          first = .FALSE.
-
-       ENDIF
-
-       lambda    = urms * SQRT( 15.0_wp * molecular_viscosity / epsilon ) ! in m
+       REAL(wp), DIMENSION(1:radius_classes) ::  st  !< Stokes number
+       REAL(wp), DIMENSION(1:radius_classes) ::  tau !< inertial time scale
+
+       lambda    = urms * SQRT( 15.0_wp * molecular_viscosity / epsilon )
        lambda_re = urms**2 * SQRT( 15.0_wp / epsilon / molecular_viscosity )
-       tl        = urms**2 / epsilon                       ! in s
-       lf        = 0.5_wp * urms**3 / epsilon              ! in m
-       tauk      = SQRT( molecular_viscosity / epsilon )                  ! in s
-       eta       = ( molecular_viscosity**3 / epsilon )**0.25_wp          ! in m
+       tl        = urms**2 / epsilon
+       lf        = 0.5_wp * urms**3 / epsilon
+       tauk      = SQRT( molecular_viscosity / epsilon )
+       eta       = ( molecular_viscosity**3 / epsilon )**0.25_wp
        vk        = eta / tauk
 
        ao = ( 11.0_wp + 7.0_wp * lambda_re ) / ( 205.0_wp + lambda_re )
-       tt = SQRT( 2.0_wp * lambda_re / ( SQRT( 15.0_wp ) * ao ) ) * tauk  ! in s
-
-       CALL fallg    ! gives winf in m/s
+       tt = SQRT( 2.0_wp * lambda_re / ( SQRT( 15.0_wp ) * ao ) ) * tauk
+
+!
+!--    Get terminal velocity of droplets
+       CALL fallg
 
        DO  i = 1, radius_classes
-          tau(i) = winf(i) / g    ! in s
-          st(i)  = tau(i) / tauk
+          tau(i) = winf(i) / g    ! inertial time scale
+          st(i)  = tau(i) / tauk  ! Stokes number
        ENDDO
 
 !
-!--    Calculate wr (from Aayala 2008b, page 38f)
+!--    Calculate average radial relative velocity at contact (wrfin)
        z   = tt / tl
        be  = SQRT( 2.0_wp ) * lambda / lf
        bbb = SQRT( 1.0_wp - 2.0_wp * be**2 )
        d1  = ( 1.0_wp + bbb ) / ( 2.0_wp * bbb )
-       e1  = lf * ( 1.0_wp + bbb ) * 0.5_wp   ! in m
+       e1  = lf * ( 1.0_wp + bbb ) * 0.5_wp
        d2  = ( 1.0_wp - bbb ) * 0.5_wp / bbb
-       e2  = lf * ( 1.0_wp - bbb ) * 0.5_wp   ! in m
+       e2  = lf * ( 1.0_wp - bbb ) * 0.5_wp
        ccc = SQRT( 1.0_wp - 2.0_wp * z**2 )
        b1  = ( 1.0_wp + ccc ) * 0.5_wp / ccc
-       c1  = tl * ( 1.0_wp + ccc ) * 0.5_wp   ! in s
+       c1  = tl * ( 1.0_wp + ccc ) * 0.5_wp
        b2  = ( 1.0_wp - ccc ) * 0.5_wp / ccc
-       c2  = tl * ( 1.0_wp - ccc ) * 0.5_wp   ! in s
+       c2  = tl * ( 1.0_wp - ccc ) * 0.5_wp
 
        DO  i = 1, radius_classes
 
-          v1 = winf(i)        ! in m/s
-          t1 = tau(i)         ! in s
+          v1 = winf(i)
+          t1 = tau(i)
 
           DO  j = 1, i
              rrp = radclass(i) + radclass(j)
-             v2  = winf(j)                                 ! in m/s
-             t2  = tau(j)                                  ! in s
+             v2  = winf(j)
+             t2  = tau(j)
 
              v1xysq  = b1 * d1 * phi_w(c1,e1,v1,t1) - b1 * d2 * phi_w(c1,e2,v1,t1) &
                      - b2 * d1 * phi_w(c2,e1,v1,t1) + b2 * d2 * phi_w(c2,e2,v1,t1)
-             v1xysq  = v1xysq * urms**2 / t1                ! in m**2/s**2
-             vrms1xy = SQRT( v1xysq )                       ! in m/s
+             v1xysq  = v1xysq * urms**2 / t1
+             vrms1xy = SQRT( v1xysq )
 
              v2xysq  = b1 * d1 * phi_w(c1,e1,v2,t2) - b1 * d2 * phi_w(c1,e2,v2,t2) &
                      - b2 * d1 * phi_w(c2,e1,v2,t2) + b2 * d2 * phi_w(c2,e2,v2,t2)
-             v2xysq  = v2xysq * urms**2 / t2                ! in m**2/s**2
-             vrms2xy = SQRT( v2xysq )                       ! in m/s
+             v2xysq  = v2xysq * urms**2 / t2
+             vrms2xy = SQRT( v2xysq )
 
              IF ( winf(i) >= winf(j) )  THEN
@@ -523,12 +514,12 @@
                          b2 * d2* zhi(c2,e2,v1,t1,v2,t2)
              fr       = d1 * EXP( -rrp / e1 ) - d2 * EXP( -rrp / e2 )
-             v1v2xy   = v1v2xy * fr * urms**2 / tau(i) / tau(j)   ! in m**2/s**2
-             wrtur2xy = vrms1xy**2 + vrms2xy**2 - 2.0_wp * v1v2xy ! in m**2/s**2
+             v1v2xy   = v1v2xy * fr * urms**2 / tau(i) / tau(j)
+             wrtur2xy = vrms1xy**2 + vrms2xy**2 - 2.0_wp * v1v2xy
              IF ( wrtur2xy < 0.0_wp )  wrtur2xy = 0.0_wp
              wrgrav2  = pi / 8.0_wp * ( winf(j) - winf(i) )**2
-             wrfin    = SQRT( ( 2.0_wp / pi ) * ( wrtur2xy + wrgrav2) ) ! in m/s
-
-!
-!--          Calculate gr
+             wrfin    = SQRT( ( 2.0_wp / pi ) * ( wrtur2xy + wrgrav2) )
+
+!
+!--          Calculate radial distribution function (grfin)
              IF ( st(j) > st(i) )  THEN
                 sst = st(j)
@@ -546,10 +537,13 @@
              ao_gr  = ao + ( pi / 8.0_wp) * ( g / vk * tauk )**2
              fao_gr = 20.115_wp * SQRT( ao_gr / lambda_re )
-             rc     = SQRT( fao_gr * ABS( st(j) - st(i) ) ) * eta   ! in cm
+             rc     = SQRT( fao_gr * ABS( st(j) - st(i) ) ) * eta
 
              grfin  = ( ( eta**2 + rc**2 ) / ( rrp**2 + rc**2) )**( c1_gr*0.5_wp )
              IF ( grfin < 1.0_wp )  grfin = 1.0_wp
 
-             gck(i,j) = 2.0_wp * pi * rrp**2 * wrfin * grfin        ! in cm**3/s
+!
+!--          Calculate general collection kernel (without the consideration of
+!--          collection efficiencies)
+             gck(i,j) = 2.0_wp * pi * rrp**2 * wrfin * grfin
              gck(j,i) = gck(i,j)
 
@@ -559,12 +553,8 @@
     END SUBROUTINE turbsd
 
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> phi_w as a function
-!------------------------------------------------------------------------------!
     REAL(wp) FUNCTION phi_w( a, b, vsett, tau0 )
-
+!
+!--    Function used in the Ayala et al. (2008) analytical model for turbulent
+!--    effects on the collision kernel
        IMPLICIT NONE
 
@@ -576,16 +566,12 @@
 
        aa1 = 1.0_wp / tau0 + 1.0_wp / a + vsett / b
-       phi_w = 1.0_wp / aa1  - 0.5_wp * vsett / b / aa1**2  ! in s
+       phi_w = 1.0_wp / aa1  - 0.5_wp * vsett / b / aa1**2
 
     END FUNCTION phi_w
 
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> zhi as a function
-!------------------------------------------------------------------------------!
     REAL(wp) FUNCTION zhi( a, b, vsett1, tau1, vsett2, tau2 )
-
+!
+!--    Function used in the Ayala et al. (2008) analytical model for turbulent
+!--    effects on the collision kernel
        IMPLICIT NONE
 
@@ -613,5 +599,5 @@
              b / aa3**2 + ( 4.0_wp / aa4 - 1.0_wp / aa5**2 - 1.0_wp / aa1**2 ) &
              * vsett2 * 0.5_wp / b /aa6 + ( 2.0_wp * ( b / aa2 - b / aa1 ) -   &
-             vsett1 / aa2**2 + vsett2 / aa1**2 ) * 0.5_wp / b / aa3    ! in s**2
+             vsett1 / aa2**2 + vsett2 / aa1**2 ) * 0.5_wp / b / aa3
 
     END FUNCTION zhi
@@ -621,113 +607,35 @@
 ! Description:
 ! ------------
-!> Calculation of terminal velocity winf following Equations 10-138 to 10-145
-!> from (Pruppacher and Klett, 1997)
+!> Parameterization of terminal velocity following Rogers et al. (1993, J. Appl.
+!> Meteorol.)
 !------------------------------------------------------------------------------!
     SUBROUTINE fallg
- 
-       USE cloud_parameters,                                                   &
-           ONLY:  rho_l
-    
-       USE control_parameters,                                                 &
-           ONLY:  g
 
        USE particle_attributes,                                                &
            ONLY:  radius_classes
 
-
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i !<
-       INTEGER(iwp) ::  j !<
-
-       LOGICAL, SAVE ::  first = .TRUE. !<
-
-       REAL(wp), SAVE ::  cunh  !<
-       REAL(wp), SAVE ::  eta   !<
-       REAL(wp), SAVE ::  phy   !<
-       REAL(wp), SAVE ::  py    !<
-       REAL(wp), SAVE ::  rho_a !<
-       REAL(wp), SAVE ::  sigma !<
-       REAL(wp), SAVE ::  stb   !<
-       REAL(wp), SAVE ::  stok  !<
-       REAL(wp), SAVE ::  xlamb !<
-
-       REAL(wp) ::  bond        !<
-       REAL(wp) ::  x           !<
-       REAL(wp) ::  xrey        !<
-       REAL(wp) ::  y           !<
-
-       REAL(wp), DIMENSION(1:7), SAVE  ::  b !<
-       REAL(wp), DIMENSION(1:6), SAVE  ::  c !<
-
-!
-!--    Initial assignment of constants
-       IF ( first )  THEN
-
-          first = .FALSE.
-          b = (/  -0.318657E1_wp,   0.992696E0_wp,  -0.153193E-2_wp, &
-                  -0.987059E-3_wp, -0.578878E-3_wp,  0.855176E-4_wp, &
-                  -0.327815E-5_wp /)
-          c = (/  -0.500015E1_wp,   0.523778E1_wp,  -0.204914E1_wp,   &
-                   0.475294E0_wp,  -0.542819E-1_wp,  0.238449E-2_wp /)
-
-!
-!--       Parameter values for p = 1013,25 hPa and T = 293,15 K
-          eta   = 1.818E-5_wp         ! in kg/(m s)
-          xlamb = 6.6E-8_wp           ! in m
-          rho_a = 1.204_wp            ! in kg/m**3
-          cunh  = 1.26_wp * xlamb     ! in m
-          sigma = 0.07363_wp          ! in kg/s**2
-          stok  = 2.0_wp  * g * ( rho_l - rho_a ) / ( 9.0_wp * eta ) ! in 1/(m s)
-          stb   = 32.0_wp * rho_a * ( rho_l - rho_a) * g / (3.0_wp * eta * eta)
-          phy   = sigma**3 * rho_a**2 / ( eta**4 * g * ( rho_l - rho_a ) )
-          py    = phy**( 1.0_wp / 6.0_wp )
-
-       ENDIF
+       INTEGER(iwp) ::  j                            !<
+
+       REAL(wp), PARAMETER ::  k_cap_rog = 4.0_wp    !< parameter
+       REAL(wp), PARAMETER ::  k_low_rog = 12.0_wp   !< parameter
+       REAL(wp), PARAMETER ::  a_rog     = 9.65_wp   !< parameter
+       REAL(wp), PARAMETER ::  b_rog     = 10.43_wp  !< parameter
+       REAL(wp), PARAMETER ::  c_rog     = 0.6_wp    !< parameter
+       REAL(wp), PARAMETER ::  d0_rog    = 0.745_wp  !< seperation diameter
+
+       REAL(wp)            ::  diameter              !< droplet diameter in mm
+
 
        DO  j = 1, radius_classes
 
-          IF ( radclass(j) <= 1.0E-5_wp )  THEN
-
-             winf(j) = stok * ( radclass(j)**2 + cunh * radclass(j) )
-
-          ELSEIF ( radclass(j) > 1.0E-5_wp  .AND.  radclass(j) <= 5.35E-4_wp )  THEN
-
-             x = LOG( stb * radclass(j)**3 )
-             y = 0.0_wp
-
-             DO  i = 1, 7
-                y = y + b(i) * x**(i-1)
-             ENDDO
-!
-!--          Note: this Eq. is wrong in (Pruppacher and Klett, 1997, p. 418)
-!--          for correct version see (Beard, 1976)
-             xrey = ( 1.0_wp + cunh / radclass(j) ) * EXP( y )
-
-             winf(j) = xrey * eta / ( 2.0_wp * rho_a * radclass(j) )
-
-          ELSEIF ( radclass(j) > 5.35E-4_wp )  THEN
-
-             IF ( radclass(j) > 0.0035_wp )  THEN
-                bond = g * ( rho_l - rho_a ) * 0.0035_wp**2 / sigma
-             ELSE
-               bond = g * ( rho_l - rho_a ) * radclass(j)**2 / sigma
-             ENDIF
-
-             x = LOG( 16.0_wp * bond * py / 3.0_wp )
-             y = 0.0_wp
-
-             DO  i = 1, 6
-                y = y + c(i) * x**(i-1)
-             ENDDO
-
-             xrey = py * EXP( y )
-
-             IF ( radclass(j) > 0.0035_wp )  THEN
-                winf(j) = xrey * eta / ( 2.0_wp * rho_a * 0.0035_wp )
-             ELSE
-                winf(j) = xrey * eta / ( 2.0_wp * rho_a * radclass(j) )
-             ENDIF
-
+          diameter = radclass(j) * 2000.0_wp
+
+          IF ( diameter <= d0_rog )  THEN
+             winf(j) = k_cap_rog * diameter * ( 1.0_wp -                       &
+                                                EXP( -k_low_rog * diameter ) )
+          ELSE
+             winf(j) = a_rog - b_rog * EXP( -c_rog * diameter )
           ENDIF
 
@@ -740,5 +648,5 @@
 ! Description:
 ! ------------
-!> Calculation of collision efficiencies for the Hall kernel
+!> Interpolation of collision efficiencies (Hall, 1980, J. Atmos. Sci.)
 !------------------------------------------------------------------------------!
     SUBROUTINE effic
@@ -776,75 +684,75 @@
 
          first = .FALSE.
-         r0  = (/   6.0_wp,   8.0_wp,  10.0_wp, 15.0_wp,  20.0_wp,  25.0_wp,  &
-                   30.0_wp,  40.0_wp,  50.0_wp, 60.0_wp,  70.0_wp, 100.0_wp,  &
+         r0  = (/   6.0_wp,   8.0_wp,  10.0_wp, 15.0_wp,  20.0_wp,  25.0_wp,   &
+                   30.0_wp,  40.0_wp,  50.0_wp, 60.0_wp,  70.0_wp, 100.0_wp,   &
                   150.0_wp, 200.0_wp, 300.0_wp /)
 
-         rat = (/ 0.00_wp, 0.05_wp, 0.10_wp, 0.15_wp, 0.20_wp, 0.25_wp,       &
-                  0.30_wp, 0.35_wp, 0.40_wp, 0.45_wp, 0.50_wp, 0.55_wp,       &
-                  0.60_wp, 0.65_wp, 0.70_wp, 0.75_wp, 0.80_wp, 0.85_wp,       &
+         rat = (/ 0.00_wp, 0.05_wp, 0.10_wp, 0.15_wp, 0.20_wp, 0.25_wp,        &
+                  0.30_wp, 0.35_wp, 0.40_wp, 0.45_wp, 0.50_wp, 0.55_wp,        &
+                  0.60_wp, 0.65_wp, 0.70_wp, 0.75_wp, 0.80_wp, 0.85_wp,        &
                   0.90_wp, 0.95_wp, 1.00_wp /)
 
-         ecoll(:,1)  = (/ 0.001_wp, 0.001_wp, 0.001_wp, 0.001_wp, 0.001_wp, &
-                          0.001_wp, 0.001_wp, 0.001_wp, 0.001_wp, 0.001_wp, &
+         ecoll(:,1)  = (/ 0.001_wp, 0.001_wp, 0.001_wp, 0.001_wp, 0.001_wp,    &
+                          0.001_wp, 0.001_wp, 0.001_wp, 0.001_wp, 0.001_wp,    &
                           0.001_wp, 0.001_wp, 0.001_wp, 0.001_wp, 0.001_wp /)
-         ecoll(:,2)  = (/ 0.003_wp, 0.003_wp, 0.003_wp, 0.004_wp, 0.005_wp, &
-                          0.005_wp, 0.005_wp, 0.010_wp, 0.100_wp, 0.050_wp, &
+         ecoll(:,2)  = (/ 0.003_wp, 0.003_wp, 0.003_wp, 0.004_wp, 0.005_wp,    &
+                          0.005_wp, 0.005_wp, 0.010_wp, 0.100_wp, 0.050_wp,    &
                           0.200_wp, 0.500_wp, 0.770_wp, 0.870_wp, 0.970_wp /)
-         ecoll(:,3)  = (/ 0.007_wp, 0.007_wp, 0.007_wp, 0.008_wp, 0.009_wp, &
-                          0.010_wp, 0.010_wp, 0.070_wp, 0.400_wp, 0.430_wp, &
+         ecoll(:,3)  = (/ 0.007_wp, 0.007_wp, 0.007_wp, 0.008_wp, 0.009_wp,    &
+                          0.010_wp, 0.010_wp, 0.070_wp, 0.400_wp, 0.430_wp,    &
                           0.580_wp, 0.790_wp, 0.930_wp, 0.960_wp, 1.000_wp /)
-         ecoll(:,4)  = (/ 0.009_wp, 0.009_wp, 0.009_wp, 0.012_wp, 0.015_wp, &
-                          0.010_wp, 0.020_wp, 0.280_wp, 0.600_wp, 0.640_wp, &
+         ecoll(:,4)  = (/ 0.009_wp, 0.009_wp, 0.009_wp, 0.012_wp, 0.015_wp,    &
+                          0.010_wp, 0.020_wp, 0.280_wp, 0.600_wp, 0.640_wp,    &
                           0.750_wp, 0.910_wp, 0.970_wp, 0.980_wp, 1.000_wp /)
-         ecoll(:,5)  = (/ 0.014_wp, 0.014_wp, 0.014_wp, 0.015_wp, 0.016_wp, &
-                          0.030_wp, 0.060_wp, 0.500_wp, 0.700_wp, 0.770_wp, &
+         ecoll(:,5)  = (/ 0.014_wp, 0.014_wp, 0.014_wp, 0.015_wp, 0.016_wp,    &
+                          0.030_wp, 0.060_wp, 0.500_wp, 0.700_wp, 0.770_wp,    &
                           0.840_wp, 0.950_wp, 0.970_wp, 1.000_wp, 1.000_wp /)
-         ecoll(:,6)  = (/ 0.017_wp, 0.017_wp, 0.017_wp, 0.020_wp, 0.022_wp, &
-                          0.060_wp, 0.100_wp, 0.620_wp, 0.780_wp, 0.840_wp, &
+         ecoll(:,6)  = (/ 0.017_wp, 0.017_wp, 0.017_wp, 0.020_wp, 0.022_wp,    &
+                          0.060_wp, 0.100_wp, 0.620_wp, 0.780_wp, 0.840_wp,    &
                           0.880_wp, 0.950_wp, 1.000_wp, 1.000_wp, 1.000_wp /)
-         ecoll(:,7)  = (/ 0.030_wp, 0.030_wp, 0.024_wp, 0.022_wp, 0.032_wp, &
-                          0.062_wp, 0.200_wp, 0.680_wp, 0.830_wp, 0.870_wp, &
+         ecoll(:,7)  = (/ 0.030_wp, 0.030_wp, 0.024_wp, 0.022_wp, 0.032_wp,    &
+                          0.062_wp, 0.200_wp, 0.680_wp, 0.830_wp, 0.870_wp,    &
                           0.900_wp, 0.950_wp, 1.000_wp, 1.000_wp, 1.000_wp /)
-         ecoll(:,8)  = (/ 0.025_wp, 0.025_wp, 0.025_wp, 0.036_wp, 0.043_wp, &
-                          0.130_wp, 0.270_wp, 0.740_wp, 0.860_wp, 0.890_wp, &
+         ecoll(:,8)  = (/ 0.025_wp, 0.025_wp, 0.025_wp, 0.036_wp, 0.043_wp,    &
+                          0.130_wp, 0.270_wp, 0.740_wp, 0.860_wp, 0.890_wp,    &
                           0.920_wp, 1.000_wp, 1.000_wp, 1.000_wp, 1.000_wp /)
-         ecoll(:,9)  = (/ 0.027_wp, 0.027_wp, 0.027_wp, 0.040_wp, 0.052_wp, &
-                          0.200_wp, 0.400_wp, 0.780_wp, 0.880_wp, 0.900_wp, &
+         ecoll(:,9)  = (/ 0.027_wp, 0.027_wp, 0.027_wp, 0.040_wp, 0.052_wp,    &
+                          0.200_wp, 0.400_wp, 0.780_wp, 0.880_wp, 0.900_wp,    &
                           0.940_wp, 1.000_wp, 1.000_wp, 1.000_wp, 1.000_wp /)
-         ecoll(:,10) = (/ 0.030_wp, 0.030_wp, 0.030_wp, 0.047_wp, 0.064_wp, &
-                          0.250_wp, 0.500_wp, 0.800_wp, 0.900_wp, 0.910_wp, &
+         ecoll(:,10) = (/ 0.030_wp, 0.030_wp, 0.030_wp, 0.047_wp, 0.064_wp,    &
+                          0.250_wp, 0.500_wp, 0.800_wp, 0.900_wp, 0.910_wp,    &
                           0.950_wp, 1.000_wp, 1.000_wp, 1.000_wp, 1.000_wp /)
-         ecoll(:,11) = (/ 0.040_wp, 0.040_wp, 0.033_wp, 0.037_wp, 0.068_wp, &
-                          0.240_wp, 0.550_wp, 0.800_wp, 0.900_wp, 0.910_wp, &
+         ecoll(:,11) = (/ 0.040_wp, 0.040_wp, 0.033_wp, 0.037_wp, 0.068_wp,    &
+                          0.240_wp, 0.550_wp, 0.800_wp, 0.900_wp, 0.910_wp,    &
                           0.950_wp, 1.000_wp, 1.000_wp, 1.000_wp, 1.000_wp /)
-         ecoll(:,12) = (/ 0.035_wp, 0.035_wp, 0.035_wp, 0.055_wp, 0.079_wp, &
-                          0.290_wp, 0.580_wp, 0.800_wp, 0.900_wp, 0.910_wp, &
+         ecoll(:,12) = (/ 0.035_wp, 0.035_wp, 0.035_wp, 0.055_wp, 0.079_wp,    &
+                          0.290_wp, 0.580_wp, 0.800_wp, 0.900_wp, 0.910_wp,    &
                           0.950_wp, 1.000_wp, 1.000_wp, 1.000_wp, 1.000_wp /)
-         ecoll(:,13) = (/ 0.037_wp, 0.037_wp, 0.037_wp, 0.062_wp, 0.082_wp, &
-                          0.290_wp, 0.590_wp, 0.780_wp, 0.900_wp, 0.910_wp, &
+         ecoll(:,13) = (/ 0.037_wp, 0.037_wp, 0.037_wp, 0.062_wp, 0.082_wp,    &
+                          0.290_wp, 0.590_wp, 0.780_wp, 0.900_wp, 0.910_wp,    &
                           0.950_wp, 1.000_wp, 1.000_wp, 1.000_wp, 1.000_wp /)
-         ecoll(:,14) = (/ 0.037_wp, 0.037_wp, 0.037_wp, 0.060_wp, 0.080_wp, &
-                          0.290_wp, 0.580_wp, 0.770_wp, 0.890_wp, 0.910_wp, &
+         ecoll(:,14) = (/ 0.037_wp, 0.037_wp, 0.037_wp, 0.060_wp, 0.080_wp,    &
+                          0.290_wp, 0.580_wp, 0.770_wp, 0.890_wp, 0.910_wp,    &
                           0.950_wp, 1.000_wp, 1.000_wp, 1.000_wp, 1.000_wp /)
-         ecoll(:,15) = (/ 0.037_wp, 0.037_wp, 0.037_wp, 0.041_wp, 0.075_wp, &
-                          0.250_wp, 0.540_wp, 0.760_wp, 0.880_wp, 0.920_wp, &
+         ecoll(:,15) = (/ 0.037_wp, 0.037_wp, 0.037_wp, 0.041_wp, 0.075_wp,    &
+                          0.250_wp, 0.540_wp, 0.760_wp, 0.880_wp, 0.920_wp,    &
                           0.950_wp, 1.000_wp, 1.000_wp, 1.000_wp, 1.000_wp /)
-         ecoll(:,16) = (/ 0.037_wp, 0.037_wp, 0.037_wp, 0.052_wp, 0.067_wp, &
-                          0.250_wp, 0.510_wp, 0.770_wp, 0.880_wp, 0.930_wp, &
+         ecoll(:,16) = (/ 0.037_wp, 0.037_wp, 0.037_wp, 0.052_wp, 0.067_wp,    &
+                          0.250_wp, 0.510_wp, 0.770_wp, 0.880_wp, 0.930_wp,    &
                           0.970_wp, 1.000_wp, 1.000_wp, 1.000_wp, 1.000_wp /)
-         ecoll(:,17) = (/ 0.037_wp, 0.037_wp, 0.037_wp, 0.047_wp, 0.057_wp, &
-                          0.250_wp, 0.490_wp, 0.770_wp, 0.890_wp, 0.950_wp, &
+         ecoll(:,17) = (/ 0.037_wp, 0.037_wp, 0.037_wp, 0.047_wp, 0.057_wp,    &
+                          0.250_wp, 0.490_wp, 0.770_wp, 0.890_wp, 0.950_wp,    &
                           1.000_wp, 1.000_wp, 1.000_wp, 1.000_wp, 1.000_wp /)
-         ecoll(:,18) = (/ 0.036_wp, 0.036_wp, 0.036_wp, 0.042_wp, 0.048_wp, &
-                          0.230_wp, 0.470_wp, 0.780_wp, 0.920_wp, 1.000_wp, &
+         ecoll(:,18) = (/ 0.036_wp, 0.036_wp, 0.036_wp, 0.042_wp, 0.048_wp,    &
+                          0.230_wp, 0.470_wp, 0.780_wp, 0.920_wp, 1.000_wp,    &
                           1.020_wp, 1.020_wp, 1.020_wp, 1.020_wp, 1.020_wp /)
-         ecoll(:,19) = (/ 0.040_wp, 0.040_wp, 0.035_wp, 0.033_wp, 0.040_wp, &
-                          0.112_wp, 0.450_wp, 0.790_wp, 1.010_wp, 1.030_wp, &
+         ecoll(:,19) = (/ 0.040_wp, 0.040_wp, 0.035_wp, 0.033_wp, 0.040_wp,    &
+                          0.112_wp, 0.450_wp, 0.790_wp, 1.010_wp, 1.030_wp,    &
                           1.040_wp, 1.040_wp, 1.040_wp, 1.040_wp, 1.040_wp /)
-         ecoll(:,20) = (/ 0.033_wp, 0.033_wp, 0.033_wp, 0.033_wp, 0.033_wp, &
-                          0.119_wp, 0.470_wp, 0.950_wp, 1.300_wp, 1.700_wp, &
+         ecoll(:,20) = (/ 0.033_wp, 0.033_wp, 0.033_wp, 0.033_wp, 0.033_wp,    &
+                          0.119_wp, 0.470_wp, 0.950_wp, 1.300_wp, 1.700_wp,    &
                           2.300_wp, 2.300_wp, 2.300_wp, 2.300_wp, 2.300_wp /)
-         ecoll(:,21) = (/ 0.027_wp, 0.027_wp, 0.027_wp, 0.027_wp, 0.027_wp, &
-                          0.125_wp, 0.520_wp, 1.400_wp, 2.300_wp, 3.000_wp, &
+         ecoll(:,21) = (/ 0.027_wp, 0.027_wp, 0.027_wp, 0.027_wp, 0.027_wp,    &
+                          0.125_wp, 0.520_wp, 1.400_wp, 2.300_wp, 3.000_wp,    &
                           4.000_wp, 4.000_wp, 4.000_wp, 4.000_wp, 4.000_wp /)
        ENDIF
@@ -852,5 +760,5 @@
 !
 !--    Calculate the radius class index of particles with respect to array r
-!--    Radius has to be in Âµm
+!--    Radius has to be in microns
        ALLOCATE( ira(1:radius_classes) )
        DO  j = 1, radius_classes
@@ -867,5 +775,5 @@
 !
 !--    Two-dimensional linear interpolation of the collision efficiency.
-!--    Radius has to be in Âµm
+!--    Radius has to be in microns
        DO  j = 1, radius_classes
           DO  i = 1, j
@@ -878,6 +786,6 @@
              IF ( ir < 16 )  THEN
                 IF ( ir >= 2 )  THEN
-                   pp = ( ( MAX(radclass(j),radclass(i)) * 1.0E06_wp ) - r0(ir-1) ) / &
-                        ( r0(ir) - r0(ir-1) )
+                   pp = ( ( MAX( radclass(j), radclass(i) ) * 1.0E6_wp ) -     &
+                          r0(ir-1) ) / ( r0(ir) - r0(ir-1) )
                    qq = ( rq - rat(iq-1) ) / ( rat(iq) - rat(iq-1) )
                    ec(j,i) = ( 1.0_wp - pp ) * ( 1.0_wp - qq )                 &
@@ -911,5 +819,6 @@
 ! Description:
 ! ------------
-!> Calculation of enhancement factor for collision efficencies due to turbulence
+!> Interpolation of turbulent enhancement factor for collision efficencies
+!> following Wang and Grabowski (2009, Atmos. Sci. Let.)
 !------------------------------------------------------------------------------!
     SUBROUTINE turb_enhance_eff
@@ -940,5 +849,4 @@
 
        REAL(wp), DIMENSION(1:11), SAVE ::  rat           !<
-       
        REAL(wp), DIMENSION(1:7), SAVE  ::  r0            !<
        
@@ -958,5 +866,5 @@
                    0.7_wp, 0.8_wp, 0.9_wp, 1.0_wp /)
 !
-!--       for 100 cm**2/s**3
+!--       Tabulated turbulent enhancement factor at 100 cm**2/s**3
           ecoll_100(:,1)  = (/  1.74_wp,   1.74_wp,   1.773_wp, 1.49_wp,  &
                                 1.207_wp,  1.207_wp,  1.0_wp /)
@@ -979,8 +887,8 @@
           ecoll_100(:,10) = (/  1.570_wp,  1.570_wp,  1.244_wp, 1.166_wp, &
                                 1.088_wp,  1.088_wp,  1.0_wp /)
-          ecoll_100(:,11) = (/ 20.3_wp,   20.3_wp,   14.6_wp,  8.61_wp,  &
+          ecoll_100(:,11) = (/ 20.3_wp,   20.3_wp,   14.6_wp,   8.61_wp,  &
                                 2.60_wp,   2.60_wp,   1.0_wp /)
 !
-!--       for 400 cm**2/s**3
+!--       Tabulated turbulent enhancement factor at 400 cm**2/s**3
           ecoll_400(:,1)  = (/  4.976_wp,  4.976_wp,  3.593_wp,  2.519_wp, &
                                 1.445_wp,  1.445_wp,  1.0_wp /)
@@ -1010,5 +918,5 @@
 !
 !--    Calculate the radius class index of particles with respect to array r0
-!--    Radius has to be in Âµm
+!--    The droplet radius has to be given in microns.
        ALLOCATE( ira(1:radius_classes) )
 
@@ -1025,6 +933,6 @@
 
 !
-!--    Two-dimensional linear interpolation of the collision efficiencies
-!--    Radius has to be in Âµm
+!--    Two-dimensional linear interpolation of the turbulent enhancement factor.
+!--    The droplet radius has to be given in microns.
        DO  j =  1, radius_classes
           DO  i = 1, j
@@ -1040,10 +948,10 @@
              ENDDO
 
-             y1 = 0.0001_wp      ! for 0 m**2/s**3
+             y1 = 1.0_wp  ! turbulent enhancement factor at 0 m**2/s**3
 
              IF ( ir < 8 )  THEN
                 IF ( ir >= 2 )  THEN
-                   pp = ( MAX(radclass(j),radclass(i))*1.0E6_wp - r0(ir-1) ) / &
-                        ( r0(ir) - r0(ir-1) )
+                   pp = ( MAX( radclass(j), radclass(i) ) * 1.0E6_wp -  &
+                          r0(ir-1) ) / ( r0(ir) - r0(ir-1) )
                    qq = ( rq - rat(iq-1) ) / ( rat(iq) - rat(iq-1) )
                    y2 = ( 1.0_wp - pp ) * ( 1.0_wp - qq ) * ecoll_100(ir-1,iq-1) + &
@@ -1066,5 +974,5 @@
              ENDIF
 !
-!--          Linear interpolation of dissipation rate in m**2/s**3
+!--          Linear interpolation of turbulent enhancement factor
              IF ( epsilon <= 0.01_wp )  THEN
                 ecf(j,i) = ( epsilon - 0.01_wp ) / ( 0.0_wp  - 0.01_wp ) * y1 &
